from typing import Self

from morpion.types import U8, U128, Char, ColumnNb, RowNb

class UserId:
    def __init__(self) -> None: ...
    @classmethod
    def valid_values_range(cls) -> tuple[U128, U128]: ...
    @classmethod
    def from_str(cls, serialized_str: str) -> Self: ...
    @classmethod
    def from_u128(cls, serialized_u128: U128) -> Self: ...
    def __str__(self) -> str: ...
    def __eq__(self, other: Self) -> bool: ...  # type: ignore

class MorpionAction:
    def __init__(self, position: tuple[ColumnNb, RowNb], board_box: Char) -> None: ...

class Morpion:
    def __init__(
        self,
        column_nb: ColumnNb,
        row_nb: RowNb,
        winning_row_length: U8,
        py_players: list[UserId],
        board_data: list[Char] | None = None,
    ) -> None: ...
    @classmethod
    def load_str(cls, serialized_str: str) -> Self: ...
    def save(self) -> str: ...
    def get_current_player(self) -> int: ...
    def get_next_player(self) -> int: ...
    def play(self, action: MorpionAction) -> int: ...
    def win(self, last_game_action: MorpionAction) -> bool: ...
    def str(self) -> str: ...
